---
version: '3.8'
services:
  zookeeper:
    image: confluentinc/cp-zookeeper:7.2.1
    hostname: zookeeper
    container_name: zookeeper
    ports:
      - "2181:2181"
    environment:
      ZOOKEEPER_CLIENT_PORT: 2181
      ZOOKEEPER_TICK_TIME: 2000

  broker1:
    image: confluentinc/cp-kafka:7.2.1
    hostname: broker1
    container_name: broker1
    depends_on:
      - zookeeper
    ports:
      - "29092:29092"
      - "9092:9092"
      - "9101:9101"
    environment:
      KAFKA_BROKER_ID: 1
      KAFKA_ZOOKEEPER_CONNECT: 'zookeeper:2181'
      KAFKA_LISTENER_SECURITY_PROTOCOL_MAP: INTERNAL:PLAINTEXT,EXTERNAL:PLAINTEXT
      KAFKA_INTER_BROKER_LISTENER_NAME: INTERNAL
      KAFKA_ADVERTISED_LISTENERS: INTERNAL://broker1:29092,EXTERNAL://localhost:9092
      KAFKA_DEFAULT_REPLICATION_FACTOR: 3
      KAFKA_NUM_PARTITIONS: 12

  schema-registry:
    image: confluentinc/cp-schema-registry:7.2.1
    hostname: schema-registry
    container_name: schema-registry
    depends_on:
      - zookeeper
      - broker1
    ports:
      - "8081:8081"
    environment:
      SCHEMA_REGISTRY_HOST_NAME: schema-registry
      SCHEMA_REGISTRY_KAFKASTORE_BOOTSTRAP_SERVERS: broker1:29092
      SCHEMA_REGISTRY_LISTENERS: http://0.0.0.0:8081

  kafkatool:
    image: provectuslabs/kafka-ui
    container_name: kafkatool
    depends_on:
      - zookeeper
      - broker1
      - schema-registry
    environment:
      KAFKA_CLUSTERS_0_NAME: "Local Cluster"
      KAFKA_CLUSTERS_0_ZOOKEEPER: "zookeeper:2181"
      KAFKA_CLUSTERS_0_BOOTSTRAPSERVERS: "broker1:29092"
      KAFKA_CLUSTERS_0_SCHEMAREGISTRY: "schema-registry:8081"
      KAFKA_CLUSTERS_0_SCHEMANAMETEMPLATE: "%s-value"
      KAFKA_CLUSTERS_0_KSQLDBSERVER: "ksqldb-server:8088"
      KAFKA_CLUSTERS_0_KAFKACONNECT_0_NAME: "Connect"
      KAFKA_CLUSTERS_0_KAFKACONNECT_0_ADDRESS: "connect:8083"
      KAFKA_CLUSTERS_0_JMXPORT: 9101
    ports:
      - "8080:8080"